@charset 'UTF-8';

@use '../../node_modules/normalize.css/normalize.css';

$font-family: 'Arial', sans-serif;

$color-white: #ffffff;
$color-black: #000000;

$color-bg: #073b4c;
$color-1: #ef476f;
$color-2: #ffd166;
$color-3: #06d6a0;
$color-4: #118ab2;

$z-index-cursor: 99999;


* {
  box-sizing: border-box;
  padding: 0;
  margin: 0;
  border: 0;
  font-family: $font-family;
  cursor: none;
}

html,
body {
  width: 100%;
  height: 100%;
  overflow: hidden;
}

body {
  display: grid;
  grid-template-rows: 1fr 2fr 3fr;
  place-items: center;
  background-color: $color-bg;
  color: $color-white;
}

.radio-group {
  display: flex;
  flex-direction: column;
  align-items: flex-start;
  padding: 30px;

  label {
    margin-bottom: 15px;

    input {
      display: inline-block;
      margin-right: 15px;
    }
  }
}

.links {
  display: flex;
  align-items: center;
  justify-content: center;

  a {
    display: inline-block;
    padding: 15px 20px;
    border: 1px solid $color-white;
    color: $color-white;
    text-align: center;
    text-decoration: none;
    transition: border-color .3s;

    &:hover {
      border-color: $color-1;
    }
  }
}

.cursor {
  position: fixed;
  top: 0;
  left: 0;
  display: none;
  z-index: $z-index-cursor;
  transform: translate3d(
    calc(100vw * var(--cursor-x)),
    calc(100vh * var(--cursor-y)),
    0
  );
  pointer-events: none;
}

.cursor-magnetic {
  width: 30px;
  height: 30px;
  transform: translate3d(
    calc(100vw * var(--cursor-x) - 15px),
    calc(100vh * var(--cursor-y) - 15px),
    0
  );

  span {
    display: block;
    width: 100%;
    height: 100%;
    border: 1px solid $color-white;
    transform: rotate(45deg);
    transition-property: width, height, border-color, transform;
    transition-duration: .3s;
  }

  &.fixed span {
    border-color: $color-1;
    transform: rotate(0);
  }
}

.cursor-dot {
  width: 5px;
  height: 5px;
  border-radius: 100%;
  background-color: $color-1;
  transform: translate3d(
    calc(100vw * var(--cursor-x) - 2px),
    calc(100vh * var(--cursor-y) - 2px),
    0
  );
}

.cursor-dot-follow {
  width: 20px;
  height: 20px;
  opacity: .5;
  transform: translate3d(
    calc(100vw * var(--cursor-x) - 10px),
    calc(100vh * var(--cursor-y) - 10px),
    0
  );
  transition: transform .1s ease-out;
}

.cursor-animate {
  width: 30px;
  height: 30px;
  transform: translate3d(
    calc(100vw * var(--cursor-x) - 15px),
    calc(100vh * var(--cursor-y) - 15px),
    0
  );

  span {
    position: absolute;
    top: 0;
    left: 0;
    display: inline-block;
    width: 100%;
    height: 100%;
    border: 2px solid $color-white;
    border-radius: 100%;
    animation: scale-1 1s ease-in-out 0s infinite alternate forwards;

    &::before,
    &::after {
      content: '';
      position: absolute;
      display: block;
      border-radius: 100%;
    }

    &::before {
      top: 50%;
      left: 50%;
      width: 10px;
      height: 10px;
      transform: translate(-50%, -50%);
    }

    &::after {
      box-sizing: border-box;
      top: -8px;
      left: -8px;
      width: 42px;
      height: 42px;
      border: 6px solid rgba($color-white, .3);
      animation: scale-2 1s ease-in-out 0s infinite alternate forwards;
    }
  }


  &.expand span::before {
    animation: pulse 2s ease-in-out 0s 1 normal forwards;
  }
}

@keyframes scale-1 {
  from {
    transform: scale(.7);
  }

  to {
    transform: scale(1);
  }
}

@keyframes scale-2 {
  from {
    transform: scale(.6);
  }

  to {
    transform: scale(1.3);
  }
}

@keyframes pulse {
  0% {
    box-shadow: 0 0 0 0 rgba($color-1, .8);
  }

  80% {
    box-shadow: 0 0 0 40px rgba($color-1, 0);
  }

  100% {
    box-shadow: 0 0 0 rgba($color-1, 0);
  }
}

.active {
  display: block;
}
